'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _instance = require('../Context/instance.js');

var _instance2 = _interopRequireDefault(_instance);

var _instanceData = require('./instance.data.js');

var _instanceData2 = _interopRequireDefault(_instanceData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } // require (PrototypeArray.js), 使用了: deepTree, getDeepTreeNodesByNames


// 数据
var initTabs = []; // 根据key或者name获取tabs, property用于区分是key还是value比较
var currentSelected = null;
var currentData = null; // 省市区
var streets = []; // 街道临时存储

var PickerDistrict = (0, _react.forwardRef)(function (_ref, ref) {
  // eslint-disable-line
  // 获取数据
  var loadCurrentData = function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
      var newData, dataStr;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              // 初始化数据
              newData = null;

              if (!(typeof getData === 'function')) {
                _context.next = 11;
                break;
              }

              setLoading(true);
              _context.next = 5;
              return getData();

            case 5:
              newData = _context.sent;

              if (typeof newData === 'string') {
                setErrMsg(newData);
              }
              if (!newData) {
                setErrMsg(locale('获取数据失败', 'hint_getdata_failed'));
              }
              setLoading(false);
              _context.next = 12;
              break;

            case 11:
              if (Array.isArray(data)) {
                newData = data;
              }

            case 12:
              // 格式化数据
              if (newData && newData.length && dataFormat && (dataFormat.parentPropertyName || dataFormat.namePropertyName || dataFormat.idPropertyName || dataFormat.childPropertyName)) {
                try {
                  dataStr = JSON.stringify(newData);

                  if (dataFormat.parentPropertyName) {
                    dataStr = dataStr.replace(new RegExp(dataFormat.parentPropertyName, 'igm'), 'parentid');
                  }
                  if (dataFormat.namePropertyName) {
                    dataStr = dataStr.replace(new RegExp(dataFormat.namePropertyName, 'igm'), 'name');
                  }
                  if (dataFormat.idPropertyName) {
                    dataStr = dataStr.replace(new RegExp(dataFormat.idPropertyName, 'igm'), 'id');
                  }
                  if (dataFormat.childPropertyName) {
                    dataStr = dataStr.replace(new RegExp(dataFormat.childPropertyName, 'igm'), 'parentid');
                  }
                  newData = JSON.parse(dataStr);
                } catch (error) {
                  newData = null;
                }
              }
              if (newData && newData.length) {
                currentData = newData.deepTree();
              } else {
                currentData = null;
              }
              // 初始化选中项
              loadSelected();
              // 初始化tabbar
              initTabBar();
              // 渲染页面
              if (currentData && currentData.length) {
                initList();
              }

            case 17:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function loadCurrentData() {
      return _ref2.apply(this, arguments);
    };
  }();
  // 获取选中数据


  // 初始化列表
  var initList = function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
      var initList;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              initList = getParentChildren(initTabs[initTabs.length - 1].parentid || '');

              if (!(!initList && initTabs[initTabs.length - 1].id && String(initTabs[initTabs.length - 1].id).length >= 9)) {
                _context2.next = 5;
                break;
              }

              _context2.next = 4;
              return loadStreets(initTabs[initTabs.length - 2].id);

            case 4:
              if (Array.isArray(streets) && streets && streets.length) {
                initList = streets;
              } else {
                initList = [];
              }

            case 5:
              setList(initList);

            case 6:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    return function initList() {
      return _ref4.apply(this, arguments);
    };
  }();
  // 获取街道, 失败返回false, 成功返回true


  var loadStreets = function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee4(id) {
      var _this = this;

      return _regenerator2.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              return _context4.abrupt('return', new Promise(function () {
                var _ref6 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee3(resolve) {
                  return _regenerator2.default.wrap(function _callee3$(_context3) {
                    while (1) {
                      switch (_context3.prev = _context3.next) {
                        case 0:
                          setLoading(true);
                          _context3.prev = 1;
                          _context3.next = 4;
                          return getStreet(id);

                        case 4:
                          streets = _context3.sent;
                          _context3.next = 14;
                          break;

                        case 7:
                          _context3.prev = 7;
                          _context3.t0 = _context3['catch'](1);

                          setErrMsg(locale('获取数据失败', 'hint_getdata_failed'));
                          setLoading(false);
                          streets = null;
                          resolve(false);
                          return _context3.abrupt('return');

                        case 14:
                          setLoading(false);
                          // 返回字符串, 说明有错

                          if (!(typeof streets === 'string')) {
                            _context3.next = 20;
                            break;
                          }

                          setErrMsg(streets);
                          streets = null;
                          resolve(false);
                          return _context3.abrupt('return');

                        case 20:
                          if (!(!streets || streets instanceof Array === false)) {
                            _context3.next = 24;
                            break;
                          }

                          streets = null;
                          resolve(true);
                          return _context3.abrupt('return');

                        case 24:
                          // 增加街道标识
                          streets = (streets || []).map(function (street) {
                            street.isStreet = true;
                            return street;
                          });
                          resolve(true);

                        case 26:
                        case 'end':
                          return _context3.stop();
                      }
                    }
                  }, _callee3, _this, [[1, 7]]);
                }));

                return function (_x2) {
                  return _ref6.apply(this, arguments);
                };
              }()));

            case 1:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    return function loadStreets(_x) {
      return _ref5.apply(this, arguments);
    };
  }();

  // 如果列表发生变化, 则查找选中项


  // 点击选项
  var onClickOption = function () {
    var _ref8 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee5(e, option) {
      var tabLen, spliceTabs, success;
      return _regenerator2.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              // 截取tabs
              tabLen = tabIndex + 1;
              spliceTabs = Object.clone(tabs).splice(0, tabLen);

              // 修改当前选中项

              spliceTabs[tabIndex] = option;

              // 因为useState是异步的, 直接提交会提交上一次的值
              tabs = spliceTabs;

              // 如果设置类型为省市区, 则直接提交

              if (!isLeaf()) {
                _context5.next = 8;
                break;
              }

              setTabs(spliceTabs);
              onSubmit(e, option);
              return _context5.abrupt('return');

            case 8:
              if (!(!option.children || !option.children.length)) {
                _context5.next = 25;
                break;
              }

              if (!(!option.isStreet && getStreet)) {
                _context5.next = 22;
                break;
              }

              _context5.next = 12;
              return loadStreets(option.id);

            case 12:
              success = _context5.sent;

              if (!(success && (!Array.isArray(streets) || !streets || !streets.length))) {
                _context5.next = 17;
                break;
              }

              setTabs(spliceTabs);
              onSubmit(e, option);
              return _context5.abrupt('return');

            case 17:
              setList(streets);

              // 设置tabs
              // spliceTabs[spliceTabs.length - 1].name = option.name
              spliceTabs.push({
                parentid: option.id,
                id: '',
                name: '请选择'
              });
              setTabs(spliceTabs);
              setTabIndex(spliceTabs.length - 1);
              return _context5.abrupt('return');

            case 22:
              // 街道直接提交
              setTabs(spliceTabs);
              onSubmit(e, option);
              return _context5.abrupt('return');

            case 25:

              // 补充请选择的空项
              spliceTabs.push({
                parentid: '',
                id: '',
                name: '请选择'
              });

              setTabs(spliceTabs);
              setTabIndex(tabLen);

              // 设置下级list
              setList(option.children);

            case 29:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    return function onClickOption(_x3, _x4) {
      return _ref8.apply(this, arguments);
    };
  }();

  var portal = _ref.portal,
      _ref$data = _ref.data,
      data = _ref$data === undefined ? _instanceData2.default : _ref$data,
      dataFormat = _ref.dataFormat,
      getData = _ref.getData,
      _ref$split = _ref.split,
      split = _ref$split === undefined ? '-' : _ref$split,
      _ref$type = _ref.type,
      type = _ref$type === undefined ? '' : _ref$type,
      show = _ref.show,
      value = _ref.value,
      selected = _ref.selected,
      _ref$maskAttribute = _ref.maskAttribute,
      maskAttribute = _ref$maskAttribute === undefined ? {} : _ref$maskAttribute,
      _ref$submitAttribute = _ref.submitAttribute,
      submitAttribute = _ref$submitAttribute === undefined ? {} : _ref$submitAttribute,
      _ref$cancelAttribute = _ref.cancelAttribute,
      cancelAttribute = _ref$cancelAttribute === undefined ? {} : _ref$cancelAttribute,
      getStreet = _ref.getStreet,
      others = _objectWithoutProperties(_ref, ['portal', 'data', 'dataFormat', 'getData', 'split', 'type', 'show', 'value', 'selected', 'maskAttribute', 'submitAttribute', 'cancelAttribute', 'getStreet']);

  // 声明ref
  var refElBody = (0, _react.useRef)(null);
  // context
  var context = (0, _react.useContext)(_instance2.default) || {};
  var locale = context.locale || function (remark) {
    return remark || '';
  };

  // 页签和列表

  var _useState = (0, _react.useState)([]),
      tabs = _useState[0],
      setTabs = _useState[1];

  var _useState2 = (0, _react.useState)(0),
      tabIndex = _useState2[0],
      setTabIndex = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      list = _useState3[0],
      setList = _useState3[1];

  var _useState4 = (0, _react.useState)(''),
      errMsg = _useState4[0],
      setErrMsg = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      loading = _useState5[0],
      setLoading = _useState5[1];

  // 设置列表, 如果类型为省时, 则不显示直辖市, 类型为市时, 则不显示直辖市的区


  function isLeaf() {
    // 判断点击的是否是底层
    if (type === 'province') {
      if (tabIndex === 0) return true;
    } else if (type === 'city') {
      if (tabIndex === 1) return true;
    } else if (type === 'district') {
      if (tabIndex === 2) return true;
    }
    return false;
  }

  // 获取父节点下所有的子节点
  function getParentChildren(parentid) {
    if (!parentid || parentid === '-1') {
      return currentData;
    }
    if (currentData && currentData.length) {
      var parent = currentData.getDeepTreeNode(parentid);
      return parent.children;
    }
    setErrMsg(locale('暂无数据', 'no_data'));
    return [];
  }

  // 数据初始化
  (0, _react.useEffect)(function () {
    if (show) {
      loadCurrentData();
    }
  }, [show]);function loadSelected() {
    // 有选中数据直接返回选中数据
    if (selected && selected.length) {
      // 如果选中项的参数不全, 则返回空
      for (var _iterator = selected, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
        var _ref3;

        if (_isArray) {
          if (_i >= _iterator.length) break;
          _ref3 = _iterator[_i++];
        } else {
          _i = _iterator.next();
          if (_i.done) break;
          _ref3 = _i.value;
        }

        var item = _ref3;

        if (!item.id || !item.name) {
          currentSelected = null;
          return null;
        }
      }
      currentSelected = selected;
      return selected;
    }
    // 没有城市数据返回空
    if (!currentData || !currentData.length) {
      currentSelected = null;
      return null;
    }
    // 没有选中数据从value中取
    var values = [];
    if (value && value.split(split)) {
      values = value.split(split);
    }
    if (!values || !values.length) {
      currentSelected = null;
      return null;
    }
    // 根据values取出选中数据
    currentSelected = currentData.getDeepTreeNodesByNames(values);
    return currentSelected;
  }
  // 初始化tabs
  function initTabBar() {
    initTabs = [];
    if (currentSelected && currentSelected.length) {
      initTabs = currentSelected;
    }
    if (initTabs && initTabs.length) {
      initTabs[initTabs.length - 1].name = '请选择';
    } else {
      initTabs[0] = {
        parentid: '',
        id: '',
        name: '请选择'
      };
    }
    setTabs(initTabs);
    setTabIndex(initTabs.length - 1);
  }(0, _react.useEffect)(function () {
    if (!refElBody || !refElBody.current) {
      return;
    }
    var activeEl = refElBody.current.querySelector('.active');
    if (activeEl) {
      refElBody.current.scrollTop = activeEl.offsetTop - activeEl.clientHeight * 2 - 20;
    }
  }, [list]);

  // 点击面板
  function onClickPanel(e) {
    e.stopPropagation();
  }
  // 点击tab
  function onClickTab(tab, index) {
    setErrMsg('');
    // 点击街道
    if (tab.isStreet && streets && streets.length) {
      setTabIndex(index);
      setList(streets);
      return;
    }
    // 点击非街道
    var children = getParentChildren(tab.parentid);
    if (children) {
      setTabIndex(index);
      setList(children);
    }
  }
  // 构建选中项
  function getOptions(lastOption) {
    var options = Object.clone(tabs);
    options[options.length - 1] = lastOption;
    return options;
  }
  function getOptionsStr(options) {
    var val = [];
    for (var _iterator2 = options, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
      var _ref7;

      if (_isArray2) {
        if (_i2 >= _iterator2.length) break;
        _ref7 = _iterator2[_i2++];
      } else {
        _i2 = _iterator2.next();
        if (_i2.done) break;
        _ref7 = _i2.value;
      }

      var option = _ref7;

      val.push(option.name);
    }
    return val.join(split);
  }
  // 提交
  function onSubmit(e, option) {
    var options = getOptions(option);
    var optionsStr = getOptionsStr(options);
    if (submitAttribute && submitAttribute.onClick) {
      submitAttribute.onClick(e, optionsStr, options);
    }
  }
  return (0, _reactDom.createPortal)(_react2.default.createElement(
    'div',
    _extends({
      ref: ref
    }, maskAttribute, {
      className: 'mask picker-district-mask' + (maskAttribute.className ? ' ' + maskAttribute.className : '') + (show ? ' active' : '')
    }),
    _react2.default.createElement(
      'div',
      _extends({
        'data-animation': 'slideUp'
      }, others, {
        className: 'picker-district' + (others.className ? ' ' + others.className : ' popup-animation bottom-center') + (show ? ' active' : ''),
        onClick: onClickPanel
      }),
      _react2.default.createElement(
        'div',
        { className: 'picker-district-header' },
        '\u8BF7\u9009\u62E9\u6240\u5728\u5730\u533A'
      ),
      _react2.default.createElement(
        'div',
        { className: 'picker-district-tabbar' },
        tabs.map(function (tab, index) {
          return _react2.default.createElement(
            'div',
            { onClick: function onClick() {
                return onClickTab(tab, index);
              }, className: 'picker-district-tab' + (index === tabIndex ? ' active' : ''), key: index },
            tab.name
          );
        })
      ),
      _react2.default.createElement(
        'div',
        { className: 'picker-district-body', ref: refElBody },
        list && list.map(function (item, index) {
          return _react2.default.createElement(
            'div',
            { key: index, onClick: function onClick(e) {
                return onClickOption(e, item);
              }, className: 'picker-district-option' + (tabs[tabIndex] && tabs[tabIndex].id === item.id ? ' active' : '') },
            _react2.default.createElement('div', { className: 'picker-district-option-icon' }),
            _react2.default.createElement(
              'div',
              { className: 'picker-district-option-caption' },
              item.name
            )
          );
        })
      ),
      errMsg && _react2.default.createElement(
        'div',
        { className: 'picker-district-error' },
        _react2.default.createElement('div', { className: 'picker-district-error-icon' }),
        _react2.default.createElement(
          'div',
          { className: 'picker-district-error-label' },
          errMsg
        )
      ),
      loading && _react2.default.createElement(
        'div',
        { className: 'picker-district-load' },
        _react2.default.createElement('div', { className: 'picker-district-load-icon' }),
        _react2.default.createElement(
          'div',
          { className: 'picker-district-load-label' },
          locale('加载中...', 'in_loading')
        )
      )
    )
  ), portal || context.portal || document.getElementById('root') || document.body);
});

exports.default = PickerDistrict;
module.exports = exports['default'];